import React, {useId} from 'react';
import routes from './routes'
import {Outlet, useNavigate, useRoutes} from 'react-router-dom'
import useIpcRenderer from '../src/utils/useIpcRenderer'
import {dirAdd} from "./redux/dirMessage_reducer";
import {pushHotkeys} from "./redux/pushHotkeys_reducer";
import {useDispatch} from "react-redux";

function App() {

  let navigateFunction = useNavigate();
  const dispatch = useDispatch();
  function nativeTo(path){
    navigateFunction(path)
  }
  const redirectUrl =(event,args)=> {
    nativeTo(args)
  }
  const addNewDir =(event,args)=> {
    dispatch(dirAdd(args))
  }
  const pushHotkeysAction =(event,args)=> {
    console.log("store.dispatch(pushHotkeys(args))",args)
    dispatch(pushHotkeys(args))
  }

  console.log("routes",routes)
  const element = useRoutes(routes)
  useIpcRenderer({'redirectUrl':redirectUrl})
  useIpcRenderer({'openDirectory':addNewDir})
  // useIpcRenderer({'pushHotkeys':pushHotkeysAction})
  return (
    <>
      {/* 注册路由 */}
      {element}
    </>
  )

};
export default App;